"""
@File    :   2.py
@Time    :   2021/03/19 17:18:57
@Author  :   lijc210@163.com
@Desc    :   None
"""
import ezdxf

# Create a new DXF document.
doc = ezdxf.new(dxfversion="R2010")

# Create new table entries (layers, linetypes, text styles, ...).
doc.layers.new("TEXTLAYER", dxfattribs={"color": 2})

# DXF entities (LINE, TEXT, ...) reside in a layout (modelspace,
# paperspace layout or block definition).
msp = doc.modelspace()

# Add entities to a layout by factory methods: layout.add_...()
msp.add_line((0, 0), (10, 10), dxfattribs={"color": 7})
msp.add_text("Test", dxfattribs={"layer": "TEXTLAYER"}).set_pos(
    (0, 0.2), align="CENTER"
)

# Save DXF document.
doc.saveas("test.dxf")
